/* Program umcopy.c     */
/* By Harald Stauss     */
/* Last change 25.08.98 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "/home/stauss/tsa/tsa.h"

#define MAXDAT 20

main(int argc, char *argv[])
{
  short    i,j,ndat,nch;
  float    sr;
  unsigned long     n;
  char     *fin,*fout,*ftin,*ftout, hs[20], fo[255];
  char     *pfin, *pfout, *pftin, *pftout;
  REGIST   r[MAXDAT],f[MAXDAT];


  /* H e l l o   w o r l d */
  cout << "UMCOPY Ver.1.3 by H. Stauss, 1998 \n";

  /* A r r a y s   a l l o c i e r e n */
  fin=(char *)malloc(255);
  pfin=fin;
  fout=(char *)malloc(255);
  pfout=fout;
  ftin=(char *)malloc(255);
  pftin=ftin;
  ftout=(char *)malloc(255);
  pftout=ftout;

  /* M e s s a g e   */
  if(argc<5) {
    cout << "transposes the files in the parameter list and \n";
    cout << "writes several output files,  \n";
    cout << "one for the first nch channels. \n";
    cout << "umcopy in1 in2 in3 in4 ... in{n} out nch [sr] \n ";
    cout << "[sr] : if in-files ASCII \n";
    goto ende;
  }

  /* P a r a m e t e r   e i n l e s e n */
  strcpy(fin,argv[1]);
  strcpy(ftin,fin);
  pftin=strrchr(ftin,'.');
  for (j=0; pftin[j]; j++) pftin[j]=toupper(pftin[j]);
  if (strcmp(pftin,".ASC")==0) {
    ndat=argc-4;
    sr=atof(argv[argc-1]);
    if (sr==0) {
      cout << "Sampling rate must be given for ASCII files! \n";
      goto ende;
    }
  }
  if (strcmp(pftin,".TSA")==0) {
    ndat=argc-3;
  }
  if ((strcmp(pftin,".TSA")!=0) && (strcmp(pftin,".ASC")!=0)) {
    cout << "File type for input file not recognized! \n";
    goto ende;
  }
  if (ndat>MAXDAT) {
    cout << "Too many input files !!! \n";
    goto ende;
  }
  cout << "Number of input data files: " << ndat << "\n";
  nch=atoi(argv[ndat+2]);
  cout << "Number of output files:     " << nch << "\n";
  if (strcmp(pftin,".ASC")==0) cout << "Sampling rate: " << sr << "\n";
  strcpy(fout,argv[ndat+1]);
  strcpy(ftout,fout);
  pftout=strrchr(pftout,'.');
  for (j=0; pftout[j]; j++) pftout[j]=toupper(pftout[j]);
  printf("Output file : %s \n",fout);
  for (i=0; i<ndat; i++) {
    strcpy(fin,argv[i+1]);
    strcpy(ftin,fin);
    pftin=strrchr(ftin,'.');
    for (j=0; pftin[j]; j++) pftin[j]=toupper(pftin[j]);
    printf("Input file : %s \n",fin);

    /* E i n g a b e d a t e i e n   o e f f n e n */
    if (strcmp(pftin,".TSA")==0) r[i].ReadTSA(fin);
    if (strcmp(pftin,".ASC")==0) r[i].ReadASCII(fin,sr);
    if ((strcmp(pftin,".TSA")!=0) && (strcmp(pftin,".ASC")!=0)) {
      cout << "File type for input file " << i+1 << "  not recognized! \n";
      goto ende;
    }
    printf("Number of channels in file %d  : %d  \n",i+1,r[i].n);
  }


  for(i=0; i<nch; i++) {
    for (j=0; j<ndat; j++) {
      f[i].AddChannel(r[j].ch[i].n, r[j].ch[i].sr, 
		      r[j].ch[i].min, r[j].ch[i].max, r[j].ch[i].res,
		      r[j].ch[i].name, r[j].ch[i].unit);
    }
  }

  /* M A I N L O O P  */
  for (j=0; j<ndat; j++) {                   // Dateien;
    for (i=0; i<nch; i++) {               // Kanaele;
      for (n=0; n<r[0].ch[0].n; n++) {       // Messwerte;
	f[i].ch[j].data[n]=r[j].ch[i].data[n];
      }
    } /* endfor */
  }

  /* D a t e i e n   s c h r e i b e n */
  for (i=0; i<nch; i++) {
    sprintf(hs,".%d",i); strcpy(fo,fout); strcat(fo,hs);
    if (strcmp(pftout,".TSA")==0) f[i].WriteTSA(fo);
    if (strcmp(pftout,".ASC")==0) f[i].WriteASCII(fo);
    if ((strcmp(pftout,".TSA")!=0) && (strcmp(pftout,".ASC")!=0)) {
      printf("File type for output not recognized! \n");
      goto ende;
    }
  }

 ende:
  free(fin);free(ftin);free(fout);free(ftout);
  return(0);
} /* Ende von main */
